【CodeForces506A】【DP】【记忆化搜索】Mr. Kitayuta, the Treasure Hunter 题解

来源:互联网 发布:美工是什么职位类别 编辑:程序博客网 时间:2024/05/22 14:34

Mr. Kitayuta, the Treasure Hunter

The Shuseki Islands are an archipelago of 30001 small islands in the Yutampo Sea. The islands are evenly spaced along a line, numbered from 0 to 30000 from the west to the east. These islands are known to contain many treasures. There are n gems in the Shuseki Islands in total, and the i-th gem is located on island pi.

Mr. Kitayuta has just arrived at island 0. With his great jumping ability, he will repeatedly perform jumps between islands to the east according to the following process:

First, he will jump from island 0 to island d.
After that, he will continue jumping according to the following rule. Let l be the length of the previous jump, that is, if his previous jump was from island prev to island cur, let l = cur - prev. He will perform a jump of length l - 1, l or l + 1 to the east. That is, he will jump to island (cur + l - 1), (cur + l) or (cur + l + 1) (if they exist). The length of a jump must be positive, that is, he cannot perform a jump of length 0 when l = 1. If there is no valid destination, he will stop jumping.
Mr. Kitayuta will collect the gems on the islands visited during the process. Find the maximum number of gems that he can collect.

Input
The first line of the input contains two space-separated integers n and d (1 ≤ n, d ≤ 30000), denoting the number of the gems in the Shuseki Islands and the length of the Mr. Kitayuta’s first jump, respectively.

The next n lines describe the location of the gems. The i-th of them (1 ≤ i ≤ n) contains a integer pi (d ≤ p1 ≤ p2 ≤ … ≤ pn ≤ 30000), denoting the number of the island that contains the i-th gem.

Output
Print the maximum number of gems that Mr. Kitayuta can collect.

Example
Input
4 10
10
21
27
27
Output
3
Input
8 8
9
19
28
36
45
55
66
78
Output
6
Input
13 7
8
8
9
16
17
17
18
21
23
24
24
26
30
Output
4
Note
In the first sample, the optimal route is 0  →  10 (+1 gem)  →  19  →  27 (+2 gems)  → …

In the second sample, the optimal route is 0  →  8  →  15  →  21 →  28 (+1 gem)  →  36 (+1 gem)  →  45 (+1 gem)  →  55 (+1 gem)  →  66 (+1 gem)  →  78 (+1 gem)  → …

In the third sample, the optimal route is 0  →  7  →  13  →  18 (+1 gem)  →  24 (+2 gems)  →  30 (+1 gem)  → …

题意:
有30000个岛屿从左到右排列,
给你一个n一个d,n代表有n个宝石分别,
接下来n行表示每个宝石分别在哪个岛屿上,
d代表你第一次从0开始跳跃到的位置,
以后你每次可以从你的位置跳跃l-1,l,l+1的距离。

题解:
首先容易想到坠暴力的方法:
定义状态dp[i][j]代表到达i位置上一步的大小是j的情况下最多捡到的宝石数,按照题意模拟即可
但是这样在时间和空间上都是不被允许的
因为只有30000个点,所以步幅的变化范围上下不会超过250,最后的d不超过500。
那么直接搞就好了

我写的记忆化搜索

附AC代码:

#include <iostream>#include <cstdio>#include <cstring>#include <cstdlib>#include <cmath>#include <vector>#include <queue>#include <stack>#include <map>#include <set>#include <string>#include <iomanip>#include <ctime>#include <climits>#include <cctype>#include <algorithm>#define clr(x) memset(x,0,sizeof(x))#define ms(a,x) memset(x,a,sizeof(x))#define LL long long#ifdef WIN32#define AUTO "%I64d"#else#define AUTO "%lld"#endifusing namespace std; const int maxn = 30005;const int stp = 505;int n,d,x,ans,maxx;int num[maxn],sum[maxn];int dp[maxn][stp];int sp[] = {-1, 0, 1};int dfs(int pos, int l) {    int sit = pos+l+d;    if(l+d < 1 || sit > maxx) return 0;    if(dp[sit][l+250] != -1) return dp[sit][l+250];    if(l+d <= 2) {        dp[sit][l+250] = sum[sit];        return dp[sit][l+250];    }    if(l+d == 3) {        dp[sit][l+250] = sum[sit+2]+num[sit];        return dp[sit][l+250];    }    int he = 0;    for(int i = 0; i < 3; i++) {        int xl = l+sp[i];        he = max(he, dfs(sit, xl));    }    he += num[sit];    return dp[sit][l+250] = he;}void init() {    ms(-1, dp);    scanf("%d%d",&n,&d);    for(int i = 0; i < n; i++) scanf("%d",&x), maxx = max(x, maxx), num[x]++;    for(int i = maxx; i >= 1; i--) sum[i] = sum[i+1]+num[i];}int main() {    init();    ans = dfs(0, 0);    printf("%d\n",ans);    return 0;}
0 0
原创粉丝点击